package cz.muni.fi.pb162.generics;

/**
 * Generické typy sú využívané v prípade ak nevieme aký typ budeme potrebovať za behu programu
 * Slúžia nám aj v prípade ak chceme vytvoriť rovnakú funkcionalitu pre viacero typov
 * Generiká sú nad rámec predmetu PB162
 *
 * Príklad jednoduchej generickej triedy je trieda DatabaseTable v tomto balíčku
 */
public class Demo {
    public static void main(String[] args) {
        // nový objekt generickej triedy vytvoríme podobne ako bežnú triedu akurát jej určíme typ
        DatabaseTable<String> stringTable = new DatabaseTable<>();
        stringTable.add("Hello World");

        // po vytvorení objektu nám kompilátor poskytuje typovú kontrolu
        // keďže je objekt typu DatabaseTable<String> nie je do neho možné vložiť Integer
        //stringTable.add(new Integer(1)); // po odkomentovaní kód nepôjde skompilovať

        // vieme vytvoriť tabuľku akéhokoľvek typu
        DatabaseTable<Integer> integerTable = new DatabaseTable<>();
    }
}
